# stage allows you to play jobs one after the other
stages:
  # create custom ansible image that will be use to feed the EC2 instance
  - build_push_custom_ansible_image
  # play unit test of the web application
  - test
  # create the EC2 instance
  - create_instance_aws_ec2
  # deploy the web application on the EC2 instance previously created
  - deploy

build_push_custom_ansible_image:
  # use "docker in docker" image
  image: gitlab/dind
  stage: build_push_custom_ansible_image
  script:
    # build the Dockerfile name (comes from environment varibale set in Gitlab CI/CD settings of the project)
    - docker build -t ${USER_DOCKER_HUB}/custom_ansible:1.0 ./custom_docker_images/ansible/
    # log in to Docker Hub website with your account (comes from environment varibale set in Gitlab CI/CD settings of the project)
    - docker login --username ${USER_DOCKER_HUB} --password ${PASS_DOCKER_HUB}
    # push your image into your account on Docker Hub
    - docker push ${USER_DOCKER_HUB}/custom_ansible:1.0

test:
  # use python image
  image: python:latest
  stage: test
  script:
    # launch unit test script
    - bash ./scripts/unit_test.sh

create_instance_aws_ec2:
  # use the custom ansible image
  image: ${USER_DOCKER_HUB}/custom_ansible:1.0
  stage: create_instance_aws_ec2
  script:
    # copy files from gitlab runner into container
    - cp -r ./custom_docker_images/ansible/* /srv
    # create a directory in the container
    - mkdir -p /srv/key_ssh/
    # echo the ssh private key (comes from environment varibale set in Gitlab CI/CD settings of the project) into a file
    - echo -e "${SSH_PRIVATE_KEY}" > /srv/key_ssh/id_rsa
    # set right permission of the ssh private key file
    - chmod 600 /srv/key_ssh/id_rsa
    # launch the playbook with extra arguments (comes from environment varibale set in Gitlab CI/CD settings of the project)
    - ansible-playbook /srv/ec2-playbook.yml -e "AWS_ACCESS_KEY_ID=${AWS_ACCESS_KEY_ID} AWS_SECRET_ACCESS_KEY=${AWS_SECRET_ACCESS_KEY}"

deploy:
  # use the custom ansible image
  image: ${USER_DOCKER_HUB}/custom_ansible:1.0
  stage: deploy
  script:
    # copy files from gitlab runner into container
    - cp -r ./custom_docker_images/ansible/* /srv
    - cp -r ./web_application /srv
    # create a directory in the container
    - mkdir -p /srv/key_ssh/
    # echo the ssh private key (comes from environment varibale set in Gitlab CI/CD settings of the project) into a file
    - echo -e "${SSH_PRIVATE_KEY}" > /srv/key_ssh/id_rsa
    # set right permission of the ssh private key file
    - chmod 600 /srv/key_ssh/id_rsa
    # launch the playbook with extra arguments (comes from environment varibale set in Gitlab CI/CD settings of the project)
    - ansible-playbook /srv/deploy-playbook.yml -e "AWS_ACCESS_KEY_ID=${AWS_ACCESS_KEY_ID} AWS_SECRET_ACCESS_KEY=${AWS_SECRET_ACCESS_KEY}"
